using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using FTD2XX_NET;
using System.Threading;

namespace EEPROM_programmer
{
    public partial class Form1 : Form
    {
        UInt32 ftdicount=0;
        FTDI.FT_STATUS ftstatus = FTDI.FT_STATUS.FT_OK;
        FTDI mydevice = new FTDI();
        FTDI.FT_MODEM_STATUS mstatus = new FTDI.FT_MODEM_STATUS();
      
 
        byte[] file_data;
        byte[] data_buff_in;
       //  byte  *p;

      //  p = new byte[100];


        public Form1()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 0;
            //itt inicializlja a programozt
            // Determine the number of FTDI devices connected to the machine
            ftstatus = mydevice.GetNumberOfDevices(ref ftdicount);
            // Check status
            if (ftstatus == FTDI.FT_STATUS.FT_OK)
            {
                richTextBox2.Text += "Found devices: " + ftdicount.ToString() + "\n";
            }
            else
            {
                richTextBox2.Text += "Error!!\n";
            }

            if (ftdicount == 0) //ha nem tall eszkzt
            {
                richTextBox2.Text += "Error, no devices were found!\n";
                return;
            }
            // Allocate storage for device info list
            FTDI.FT_DEVICE_INFO_NODE[] ftdevicelist = new FTDI.FT_DEVICE_INFO_NODE[ftdicount];
            // Populate our device list
            ftstatus = mydevice.GetDeviceList(ftdevicelist);
            if (ftstatus == FTDI.FT_STATUS.FT_OK)
            {
                for (UInt32 i = 0; i < ftdicount; i++)
                {
                    richTextBox2.Text+="Device Index: " + i.ToString()+"\n";
                    richTextBox2.Text+="Flags: " + String.Format("{0:x}", ftdevicelist[i].Flags)+"\n";
                    richTextBox2.Text += "Type: " + ftdevicelist[i].Type.ToString() + "\n";
                    richTextBox2.Text += "ID: " + String.Format("{0:x}", ftdevicelist[i].ID) + "\n";
                    richTextBox2.Text += "Location ID: " + String.Format("{0:x}", ftdevicelist[i].LocId) + "\n";
                    richTextBox2.Text += "Serial Number: " + ftdevicelist[i].SerialNumber.ToString() + "\n";
                    richTextBox2.Text += "Description: " + ftdevicelist[i].Description.ToString() + "\n";
                }

            }
            //megnyitni lers alapjn -> ez a legegyszerbb azonosts
            //USB EEPROM programmer
            ftstatus = mydevice.OpenByDescription("USB EEPROM programmer");
            if(ftstatus==FTDI.FT_STATUS.FT_OK)
            {
                richTextBox2.Text +="Device opened succesfully!\n";
                //baudratet belltani
                ftstatus = mydevice.SetBaudRate(57600);
                //klnfle belltsok
                ftstatus = mydevice.SetDataCharacteristics(FTDI.FT_DATA_BITS.FT_BITS_8, FTDI.FT_STOP_BITS.FT_STOP_BITS_1, FTDI.FT_PARITY.FT_PARITY_NONE);
                //timeout-ot
                ftstatus = mydevice.SetTimeouts(5000, 0);
 
            }
            else
            {
                richTextBox2.Text+="Error opening device!!!\n";
                MessageBox.Show("Can't find the device!\n Make sure it's connected, and please wait a few seconds after connceting the device, before starting this program.", "Error",
                MessageBoxButtons.OK, MessageBoxIcon.Warning);
         

            }

            
            //timeout


            //a kommunikci mehet valamelyik gombrl....


            //Ha idig eljut akkor minden rendben lefutott
            richTextBox2.Text += "Ready!\n";
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                
                label2.Text = openFileDialog1.FileName;
                //byte izeke = 50;
                //label2.Text = "0x"+izeke.ToString("X");
                
              //  richTextBox1.LoadFile(openFileDialog1.FileName, RichTextBoxStreamType.PlainText);
                FileInfo info = new FileInfo(openFileDialog1.FileName);
                FileStream fs = File.OpenRead(openFileDialog1.FileName);
                BinaryReader br = new BinaryReader(fs);
                file_data = br.ReadBytes((int)info.Length); //a file_data lesz tele az eepromba rand adattal
                for (int i = 0; i < info.Length / 8; i++)
                {
                   
                    for (int j = 0; j < 8; j++)
                    {
                        richTextBox1.Text += "0x";
                        if ((file_data[i*8+j].ToString("X")).Length < 2) richTextBox1.Text += "0";
                        richTextBox1.Text += file_data[i*8+j].ToString("X") + " ";
                    }
                    richTextBox1.Text += ("|");
                    for (int j = 0; j < 8; j++)
                    {
                        char c=(char)(file_data[i*8 + j]);
                        if (c==10) c=' ';
                        if (c==13) c = ' ';
                        richTextBox1.Text +=c;
                    }
                    richTextBox1.Text += "\n";
                }

                    button2.Enabled = true; //mostmr meg lehet nyomni az rs gombot
                fs.Close();
            }

        
        }

        private void button5_Click(object sender, EventArgs e)
        {
            mydevice.Close();
            Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            mydevice.SetRTS(false); //ilyenkor kap magas szintet az AVR
            checkBox3.Checked = true;
            groupBox1.Text = "Reading...";
            groupBox1.Visible = true;
            Application.DoEvents();

            //el kell kldeni neki az olvassi parancsot
            string command;
            string input_buf;
            UInt32 bytes_sent = 0;
            UInt32 bytes_avalible = 0;
            UInt32 bytes_read = 0;
            mydevice.Purge(3);
            command = "R"; //olvassi parancs
            ftstatus = mydevice.Write(command, command.Length, ref bytes_sent);
            while (bytes_avalible == 0) //addig vr amg nincs adat a bemeneten
            {
                ftstatus = mydevice.GetRxBytesAvailable(ref bytes_avalible);
                Thread.Sleep(1);
            }
            //visszaolvasni az elkldtt parancsot 
            ftstatus = mydevice.Read(out input_buf, bytes_avalible, ref bytes_read);
            if (input_buf[0] != 'R') //ha nem jtt vissza az R akkor hiba van.. 
            {
              MessageBox.Show("Device is not responding!", "Error",
              MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            mydevice.Purge(3);

            mydevice.SetRTS(true);
            checkBox3.Checked = false;

            //beolvasni annyi bjtot, amennyi az EEPROM tpusszmbl kvetkezik
            switch (comboBox1.Text)
            {
                case "28C16": 
                    { 
                        data_buff_in=new byte[2048];//2048
                        progressBar1.Maximum =2048;
                    }
                    break;
                case "28C64": 
                    {
                        data_buff_in = new byte[8192];
                        progressBar1.Maximum = 8192;
                    }
                    break;
                case "28C256":
                    {
                        data_buff_in = new byte[32768];
                        progressBar1.Maximum = 32768;
                    }
                    break;

            }
            progressBar1.Value = 0;
            UInt32 read_length = 2047; //ide majd valami rtelmesebb jn
            UInt32 byte_count = 0; //a bejtt bjtok szma

            byte[] input_buf8=new byte[8];
            int i = 0,pos=0;
            bytes_read = 0; //beolvasott bjtok szma 0
            while (byte_count <=read_length)
            {
                while (bytes_avalible == 0) //addig vr amg nincs adat a bemeneten
                {
                    ftstatus = mydevice.GetRxBytesAvailable(ref bytes_avalible);
                    Thread.Sleep(1);
                    Application.DoEvents();
                }

                ftstatus = mydevice.Read(input_buf8, 8, ref bytes_read);
             

                for (i = 0; i < 8; i++)
                {
                    data_buff_in[pos] = (byte)input_buf8[i];
                    pos++;
                }
                progressBar1.Value = pos;
                progressBar1.Update();
                Application.DoEvents();

                byte_count += (UInt32)input_buf8.Length;
           }
           mydevice.SetRTS(false);
           checkBox3.Checked = true;

           for (i = 0; i < 2047; i++)
           {
               richTextBox1.Text += data_buff_in[i].ToString()+"\n"; 
           }
           label1.Text = byte_count.ToString();
           mydevice.Purge(3);
           label2.Text = richTextBox1.Text.Length.ToString();
           

           



           groupBox1.Visible = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            mydevice.SetRTS(true); //ilyenkor kap alacsony szintet az AVR a bemenetn
            checkBox3.Checked = false;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //ez most ksrletileg lesz gy
          //  mstatus=mydevice.GetModemStatus();
            byte statusz=0;
            mydevice.GetModemStatus(ref statusz);
            if ((statusz&16)!=0) checkBox4.Checked = true; else checkBox4.Checked = false;
            label1.Text = statusz.ToString();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            mydevice.SetRTS(false); //ilyenkor kap magas szintet az AVR
            checkBox3.Checked = true;
            groupBox1.Text = "Writing...";
            groupBox1.Visible = true;
            Application.DoEvents();


            string command;
            string input_buf;
            UInt32 bytes_sent = 0;
            UInt32 bytes_avalible = 0;
            UInt32 bytes_read = 0;

            mydevice.Purge(3);
            command = "W"; //rsi parancs
            ftstatus = mydevice.Write(command, command.Length, ref bytes_sent);
            while (bytes_avalible == 0) //addig vr amg nincs adat a bemeneten
            {
                ftstatus = mydevice.GetRxBytesAvailable(ref bytes_avalible);
                Thread.Sleep(1);
            }
            //visszaolvasni az elkldtt parancsot 
            ftstatus = mydevice.Read(out input_buf, bytes_avalible, ref bytes_read);
            if (input_buf[0] != 'W') //ha nem jtt vissza az W akkor hiba van.. 
            {
                MessageBox.Show("Device is not responding!", "Error",
                MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            mydevice.Purge(3);
            mydevice.SetRTS(true);
            checkBox3.Checked = false;

            switch (comboBox1.Text)
            {
                case "28C16":
                    {
                        data_buff_in = new byte[2048];//2048
                        progressBar1.Maximum = 2048;
                    }
                    break;
                case "28C64":
                    {
                        data_buff_in = new byte[8192];
                        progressBar1.Maximum = 8192;
                    }
                    break;
                case "28C256":
                    {
                        data_buff_in = new byte[32768];
                        progressBar1.Maximum = 32768;
                    }
                    break;

            }

            UInt32 bytes_written=0;
            //rs
            ftstatus = mydevice.Write(file_data, file_data.Length, ref bytes_written);





            mydevice.SetRTS(false);
            checkBox3.Checked = true;

        }
    }
}