using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using FTD2XX_NET;
using System.Threading;

namespace EEPROM_programmer
{
    public partial class Form1 : Form
    {
        UInt32 ftdicount=0;
        FTDI.FT_STATUS ftstatus = FTDI.FT_STATUS.FT_OK;
        FTDI mydevice = new FTDI();
        FTDI.FT_MODEM_STATUS mstatus = new FTDI.FT_MODEM_STATUS();
      
 
        byte[] file_data;
        byte[] data_buff_in;
       //  byte  *p;

      //  p = new byte[100];


        public Form1()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 0;
            //itt inicializlja a programozt
            // Determine the number of FTDI devices connected to the machine
            ftstatus = mydevice.GetNumberOfDevices(ref ftdicount);
            // Check status
            if (ftstatus == FTDI.FT_STATUS.FT_OK)
            {
                richTextBox2.Text += "Found devices: " + ftdicount.ToString() + "\n";
            }
            else
            {
                richTextBox2.Text += "Error!!\n";
            }

            if (ftdicount == 0) //ha nem tall eszkzt
            {
                richTextBox2.Text += "Error, no devices were found!\n";
                return;
            }
            // Allocate storage for device info list
            FTDI.FT_DEVICE_INFO_NODE[] ftdevicelist = new FTDI.FT_DEVICE_INFO_NODE[ftdicount];
            // Populate our device list
            ftstatus = mydevice.GetDeviceList(ftdevicelist);
            if (ftstatus == FTDI.FT_STATUS.FT_OK)
            {
                for (UInt32 i = 0; i < ftdicount; i++)
                {
                    richTextBox2.Text+="Device Index: " + i.ToString()+"\n";
                    richTextBox2.Text+="Flags: " + String.Format("{0:x}", ftdevicelist[i].Flags)+"\n";
                    richTextBox2.Text += "Type: " + ftdevicelist[i].Type.ToString() + "\n";
                    richTextBox2.Text += "ID: " + String.Format("{0:x}", ftdevicelist[i].ID) + "\n";
                    richTextBox2.Text += "Location ID: " + String.Format("{0:x}", ftdevicelist[i].LocId) + "\n";
                    richTextBox2.Text += "Serial Number: " + ftdevicelist[i].SerialNumber.ToString() + "\n";
                    richTextBox2.Text += "Description: " + ftdevicelist[i].Description.ToString() + "\n";
                }

            }
            //megnyitni lers alapjn -> ez a legegyszerbb azonosts
            //USB EEPROM programmer
            ftstatus = mydevice.OpenByDescription("USB EEPROM programmer");
            if(ftstatus==FTDI.FT_STATUS.FT_OK)
            {
                richTextBox2.Text +="Device opened succesfully!\n";
                //baudratet belltani
                ftstatus = mydevice.SetBaudRate(57600);
                //klnfle belltsok
                ftstatus = mydevice.SetDataCharacteristics(FTDI.FT_DATA_BITS.FT_BITS_8, FTDI.FT_STOP_BITS.FT_STOP_BITS_1, FTDI.FT_PARITY.FT_PARITY_NONE);
                //timeout-ot
                ftstatus = mydevice.SetTimeouts(5000, 0);
 
            }
            else
            {
                richTextBox2.Text+="Error opening device!!!\n";
                MessageBox.Show("Can't find the device!\n Make sure it's connected, and please wait a few seconds after connceting the device, before starting this program.", "Error",
                MessageBoxButtons.OK, MessageBoxIcon.Warning);
         

            }

            
            //timeout


            //a kommunikci mehet valamelyik gombrl....


            //Ha idig eljut akkor minden rendben lefutott
            richTextBox2.Text += "Ready!\n";
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {

        }

        //MEGNYITS
        private void button4_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                
                label2.Text = openFileDialog1.FileName;
                
              //  richTextBox1.LoadFile(openFileDialog1.FileName, RichTextBoxStreamType.PlainText);
                FileInfo info = new FileInfo(openFileDialog1.FileName);
                FileStream fs = File.OpenRead(openFileDialog1.FileName);
                BinaryReader br = new BinaryReader(fs);
                file_data = br.ReadBytes((int)info.Length); //a file_data lesz tele az eepromba rand adattal
                groupBox1.Text = "Converting...";
                groupBox1.Visible = true;
                groupBox1.Refresh();

                progressBar1.Maximum = (int)info.Length;
                richTextBox1.Visible = false;
                string str_in="";
              
                for (int i = 0; i < info.Length / 8; i++)
                {
                    progressBar1.Value = i;
                    progressBar1.Refresh();
                    for (int j = 0; j < 8; j++)
                    {
                        str_in += "0x";
                        if ((file_data[i * 8 + j].ToString("X")).Length < 2) str_in += "0";
                        str_in += file_data[i * 8 + j].ToString("X") + " ";
                    }
                    str_in += ("|");
                    for (int j = 0; j < 8; j++)
                    {
                        char c=(char)(file_data[i*8 + j]);
                        if (c == 0) c = ' ';
                        if (c == 9) c = ' ';
                        if (c == 10) c = ' ';
                        if (c == 11) c = ' ';
                        if (c == 12) c = ' ';
                        if (c == 13) c = ' ';
                        str_in += c;
                    }
                    str_in += "\n";
                }

                richTextBox1.Text = str_in;
                button2.Enabled = true; //mostmr meg lehet nyomni az rs gombot
                fs.Close();
                richTextBox1.Visible = true;
            }
            groupBox1.Visible = false;
        
        }

        private void button5_Click(object sender, EventArgs e)
        {
            mydevice.Close();
            Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //OLVASS
            richTextBox1.Text = "";
            mydevice.SetRTS(false); //ilyenkor kap magas szintet az AVR
            checkBox3.Checked = true;
            groupBox1.Text = "Reading...";
            groupBox1.Visible = true;
            UInt32 memsize = 0;

            //belltani a memria mrett, amennyi az EEPROM tpusszmbl kvetkezik
            switch (comboBox1.Text)
            {
                case "28C16": memsize = 2048; break;
                case "28C64": memsize = 8192; break;
                case "28C256": memsize = 32768; break;
                default: break;
            }

           //kiolvassa a memria tartalmat a data_buff_in vltozba
           read_out(memsize); 
    
           groupBox1.Text = "Converting...";
           groupBox1.Refresh();
           string str_in="";
           for (int i = 0; i < (memsize/8); i++) //trakni stringbe, s megformzni
           {
               progressBar1.Value = i*8;
               progressBar1.Refresh();
               for (int j = 0; j < 8; j++)
               {
                   str_in += "0x";
                   if ((data_buff_in[i * 8 + j].ToString("X")).Length < 2) str_in += "0";
                   str_in +=data_buff_in[i * 8 + j].ToString("X") + " ";
               }
               str_in += ("|");
               for (int j = 0; j < 8; j++)
               {
                   char c = (char)(data_buff_in[i * 8 + j]);
                   if (c == 0) c = ' ';
                   if (c == 9) c = ' ';
                   if (c == 10) c = ' ';
                   if (c == 11) c = ' ';
                   if (c == 12) c = ' ';
                   if (c == 13) c = ' ';
                   str_in+= c;
               }
               str_in += "\n";


             //  str_in += data_buff_in[i].ToString()+"\n"; 
           }
           richTextBox1.Text = str_in;
       //    label1.Text = byte_count.ToString();
           mydevice.Purge(3);
           label2.Text = richTextBox1.Lines.Length.ToString();


           mydevice.SetRTS(true);
           checkBox3.Checked = false;



           groupBox1.Visible = false;
        }

        //TRLS
        private void button3_Click(object sender, EventArgs e)
        {
            groupBox1.Text = "Erasing...";
            groupBox1.Visible = true;
            groupBox1.Refresh();
            Application.DoEvents();
            UInt32 memsize = 0;

            //belltani a memria mrett, amennyi az EEPROM tpusszmbl kvetkezik
            switch (comboBox1.Text)
            {
                case "28C16": memsize = 2048; break;
                case "28C64": memsize = 8192; break;
                case "28C256": memsize = 32768; break;
                default: break;
            }


            write(memsize, 0);

            groupBox1.Visible = false;

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //ez most ksrletileg lesz gy
          //  mstatus=mydevice.GetModemStatus();
            byte statusz=0;
            mydevice.GetModemStatus(ref statusz);
            if ((statusz&16)!=0) checkBox4.Checked = true; else checkBox4.Checked = false;
            label1.Text = statusz.ToString();
        }

        //RS
        private void button2_Click(object sender, EventArgs e)
        {
            groupBox1.Text = "Writing...";
            groupBox1.Visible = true;
            groupBox1.Refresh();
            Application.DoEvents();
            UInt32 memsize = 0;

            //belltani a memria mrett, amennyi az EEPROM tpusszmbl kvetkezik
            switch (comboBox1.Text)
            {
                case "28C16": memsize = 2048; break;
                case "28C64": memsize = 8192; break;
                case "28C256": memsize = 32768; break;
                default: break;
            }


            write(memsize,1);

            if (verifycheck.Checked == true)
            {
                groupBox1.Text = "Verifying...";
                groupBox1.Refresh();
                if (verify(memsize) == true)
                {
                    MessageBox.Show("Verification was successfull!", "Verification OK!",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Verification Failed!", "Error",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);    
                }
 
            }

            groupBox1.Visible = false;
        }

        private void richTextBox1_TextChanged_1(object sender, EventArgs e)
        {

        }


        //Kiolvas fgv
        //kimenet: data_buff_in
        void read_out(UInt32 memsize)
        {
            
            progressBar1.Minimum = 0;
            progressBar1.Value = 0;
            progressBar1.Refresh();

            mydevice.SetRTS(false); //ilyenkor kap magas szintet az AVR
            checkBox3.Checked = true;
            Application.DoEvents();

            //el kell kldeni neki az olvassi parancsot
            string command = ""; //csak legyen valami
            UInt32 bytes_sent = 0;
            UInt32 bytes_avalible = 0;
            UInt32 bytes_read = 0;
            mydevice.Purge(3);

            switch (memsize)
            {
                case 2048: command = "A"; break;
                case 8192: command = "B"; break;
                case 32768: command = "C"; break;
                default: break;
            }
            ftstatus = mydevice.Write(command, command.Length, ref bytes_sent);

            Thread.Sleep(1);
            command = "R"; //olvassi parancs
            ftstatus = mydevice.Write(command, command.Length, ref bytes_sent);

            while (bytes_avalible == 0) //addig vr amg nincs adat a bemeneten
            {
                ftstatus = mydevice.GetRxBytesAvailable(ref bytes_avalible);
                Thread.Sleep(1);
            }

            //beolvasni annyi bjtot, amennyi az EEPROM tpusszmbl kvetkezik
            data_buff_in = new byte[memsize];
            progressBar1.Maximum = (int)memsize;

            UInt32 byte_count = 0; //a bejtt bjtok szma

            byte[] input_buf8 = new byte[8];
            int i = 0, pos = 0;
            bytes_read = 0; //beolvasott bjtok szma 0
            while (byte_count < memsize)
            {
                while (bytes_avalible == 0) //addig vr amg nincs adat a bemeneten
                {
                    ftstatus = mydevice.GetRxBytesAvailable(ref bytes_avalible);
                    Thread.Sleep(1);
                    Application.DoEvents();
                }

                ftstatus = mydevice.Read(input_buf8, 8, ref bytes_read);
                
                for (i = 0; i < 8; i++)
                {
                    data_buff_in[pos] = (byte)input_buf8[i];
                    pos++;
                }
                progressBar1.Value = pos;
                progressBar1.Update();
                Application.DoEvents();

                byte_count += (UInt32)input_buf8.Length;
            }


            mydevice.SetRTS(true);
            checkBox3.Checked = false;
 
        }

        void write(UInt32 memsize,UInt32 mode)
        {
            mydevice.SetRTS(false); //Magas szint, ezzel lehet megszaktani az aktulis folyamatot esetleg
            checkBox3.Checked = true;

            string command = " ";
            UInt32 bytes_sent = 0;


            switch (memsize)
            {
                case 2048: command = "A"; break;
                case 8192: command = "B"; break;
                case 32768: command = "C"; break;
                default: break;
            }
            progressBar1.Maximum = (int)memsize;
            mydevice.Write(command, command.Length, ref bytes_sent);
            Thread.Sleep(1);
            mydevice.Purge(3);
            //parancs kldse
            command = "W"; //rs
            mydevice.Write(command, command.Length, ref bytes_sent);
            Thread.Sleep(1);
         

            if (mode==1) //normlis rsi md
            {
                //adat kldse
                byte[] memdata = new byte[memsize];
                byte[] dummy = new byte[1];
                for (int j = 0; j < memsize; j++)
                {
                    if (j < file_data.Length) memdata[j] = file_data[j];
                    else memdata[j] = 255;
                }
                for (int i = 0; i < memsize; i++)
                {                  
                    dummy[0] = memdata[i];
                    mydevice.Write(dummy, dummy.Length, ref bytes_sent);
                    Thread.Sleep(10);
                    progressBar1.Value = i;
                    progressBar1.Update();
                }
            }
            if(mode==0)   //trls
            {
                //adat kldse
                byte[] dummy = new byte[1];
                dummy[0] = 255;
                for (int i = 0; i < memsize; i++)
                {
                    mydevice.Write(dummy, dummy.Length, ref bytes_sent);
                    Thread.Sleep(10);
                    progressBar1.Value = i;
                    progressBar1.Update();
                }
 
            }

            mydevice.SetRTS(true); //alacsony szint
            checkBox3.Checked = false;
       
        }

        bool verify(UInt32 memsize)
        {
            read_out(memsize);
            //meg kell nzni, hogy file_data s a data buffer_in
            //stimmel-e
            for (int i = 0; i < file_data.Length; i++)
            {
                if (file_data[i] != data_buff_in[i]) return false;   
            }

             return true;
        }



    }
}